DECLARE SUB zzzt (volts!)
DECLARE SUB BIGNUM (n!, scale!, xpos!, ypos!)
DECLARE SUB setupvars ()
'$FORM freqs
'$FORM freql
'$FORM cfg
'$FORM gen
'$FORM ego                       

COMMON /asmprog/ prog() AS INTEGER
COMMON /pointer/ p
COMMON /LCD/ EE$, AA$, a$, B$, c$, d$, E$, f$, G$, dp$, Digit() AS STRING
COMMON /letters/ Rich$, Lean$
COMMON /File/ boot_dir AS STRING
COMMON /config/ Screen_mode, Delay_Value, port$, File_Name$, Saved_trace
COMMON /help/ CFG_Help$
COMMON /cal/ cal()
COMMON /mode/ cont, Sample_and_hold, Auto_save, save, z(), Sample_time, x_min
CONST ver = "VERSION 1.11"
DIM prog(1 TO 100) AS INTEGER
DIM Digit(9) AS STRING
DIM cal(260)
DIM z(650)
p = VARPTR(prog(1))
DEF SEG = VARSEG(prog(1))

FOR i = 0 TO 60
READ d
POKE p + i, d
NEXT

DATA &H55,&H89,&He5,&Hfa,&Hba,&H78,&H03,&Hb1,&H00,&Hb3
DATA &H00,&Hb0,&Hc7,&Hee,&Hb8,&H00,&H02,&H48,&H75,&Hfd
DATA &Hb0,&Hff,&Hee,&Hb8,&H01,&H01,&H48,&H75,&Hfd,&Hb0
DATA &hf8,&hee,&hb8,&h01,&h01,&h48,&h75,&hfd,&h42,&Hec
DATA &H4a,&H24,&H80,&H74,&H02,&H8a,&Hcb,&Hfe,&Hc3,&H75
DATA &He1,&H8b,&H5e,&H06,&H88,&H0f,&H5d,&Hfb,&Hca,&H02
DATA &H00



DO
  READ a$
  m$ = m$ + a$ + CHR$(13) + CHR$(10)
LOOP UNTIL a$ = " "

DATA "PORT ADDRESS:  Use the mouse or arrow keys to highlight the parallel "
DATA "port address of your computer (usualy 0378), and the selected address"
DATA "will appear in the text box below the list. If the port address of   "
DATA "your computer isn't in the list, you can TAB to (or click on) the    "
DATA "text box and enter the port address (in Hex) directly.               "
DATA "   "
DATA "DELAY VALUE:   This value determines the sample rate of the analyser "
DATA "and should be set as low as possible. (the exact value will depend on"
DATA "the speed of your computer.) If the analyser seems to be behaving    "
DATA "erraticaly, try increasing this value. "
DATA "   "
DATA "SCREEN MODE:   Selects monochrome (black and white) or colour"
DATA "screen modes for the `Read Sensor' screen."
DATA "    "
DATA "CALCULATE:     Estimates the correct  Delay Value for your machine."
DATA "Note that this calculated value is not always spot on, particually "
DATA "with faster computers. So use it more as a starting place."
DATA " "


CFG_Help$ = m$

ego.SHOW
CALL setupvars
WHILE DOEVENTS(): WEND
END

SUB BIGNUM (n, scale, xpos, ypos)
SHARED G$, dp$, Digit() AS STRING
DEF SEG = VARSEG(s)
DRAW " s=" + VARPTR$(scale)

n$ = MID$(STR$(n), 2)
IF n < 1 THEN n$ = "0" + n$
l = LEN(n$)

PRESET (xpos, ypos)
IF l > 5 THEN
   DRAW "b d18" + G$: xpos = xpos + 7 * scale: PRESET (xpos, ypos): DRAW "b d18" + G$
   GOTO finished
END IF
FOR i = 1 TO l
   c$ = MID$(n$, i, 1)
   IF c$ = "." THEN
      DRAW dp$: xpos = xpos + scale * 2
      ELSE DRAW Digit$(VAL(c$)): xpos = xpos + 7 * scale
   END IF
   PRESET (xpos, ypos)
NEXT
finished:
END SUB

SUB plotit ()
'_________________________________________________________________________
'|                                                                        |
'|                           VBDOS setup stuff...                         |
'|________________________________________________________________________|

'ON LOCAL ERROR GOTO ErrorHandler
screen.HIDE


SHARED prog() AS INTEGER
SHARED p
SHARED Rich$, Lean$, EE$, AA$
SHARED Screen_mode, Delay_Value, port$, File_Name$, Saved_trace
SHARED cont, Sample_and_hold, Auto_save, save, z(), Sample_time, x_min

'_________________________________________________________________________
'|                                                                        |
'|                    Setup port address and delay period                 |
'|________________________________________________________________________|

DEF SEG = VARSEG(prog(1))

SCREEN Screen_mode

POKE p + 6, VAL("&H" + LEFT$(port$, 2))
POKE p + 5, VAL("&H" + RIGHT$(port$, 2))

High_delay = INT(Delay_Value / 256)
Low_Delay = Delay_Value - High_delay * 256

POKE p + 24, Low_Delay
POKE p + 25, High_delay
POKE p + 33, Low_Delay
POKE p + 34, High_delay

screen.HIDE

'_________________________________________________________________________
'|                                                                        |
'|                           Set up variables                             |
'|________________________________________________________________________|
                                                                          
'*********** Colours****************
trace = 14
trace_background = 0
grid_colour = 8
stoich_colour = 3
digit_back = 0

'********** Trace box coords *******
x_min = 13
x_max = 636
y_max = 263
y_min = 8

'********** Constants***************
volt_per_div = .2                     ' Used in drawing the grid
stoich_volt = .45                     ' Sensor voltage at stoichiometry
pix_per_volt = (255 / 1.28)           ' Used to scale trace into 255 pixels
ideal_afr = 14.7                      ' Correct AFR for petrol engines
overflow = 999999                     ' Used to get BIGNUM to display '- -'
number_samples = x_max - x_min        ' So you can resize the trace window
stoich_y = pix_per_volt * stoich_volt ' Actual Y value to draw stoich. line
save = 0
File_Name$ = freql.FileLabel.caption
IF LEN(File_Name$) < 5 THEN File_Name$ = "Default.#00"
  
IF Auto_save = 1 THEN File_Name$ = "AUTOSAVE.#00"
DIM y(640) AS INTEGER

'_________________________________________________________________________
'|                                                                        |
'|                     Draw boxes for trace and data                      |
'|________________________________________________________________________|

LINE (x_min - 3, y_min - 3)-(x_max + 3, y_max + 3), , B'|   Trace
LINE (x_min - 1, y_min - 1)-(x_max + 1, y_max + 1), , B'|   box
LINE (10, 270)-(179, 400), , B               '\
LINE (12, 290)-(177, 398), , B               '  > Crossings
LINE (13, 291)-(176, 397), digit_back, BF    '/
LINE (10, 405)-(179, 479), , B               '\
LINE (12, 407)-(177, 477), , B               '  > Rich/Lean
LINE (13, 408)-(176, 476), digit_back, BF    '/
LINE (185, 270)-(345, 380), , B              '\
LINE (187, 290)-(343, 378), , B              '  > % Oxygen
LINE (188, 291)-(342, 377), digit_back, BF   '/
LINE (185, 385)-(345, 479), , B              '\
LINE (187, 387)-(343, 477), , B              '  > Max/Min
LINE (188, 388)-(342, 476), 0, BF            '/
LINE (351, 270)-(535, 400), , B              '\
LINE (353, 290)-(533, 398), , B              '  > Lambda
LINE (354, 291)-(532, 397), digit_back, BF   '/
LINE (351, 405)-(535, 479), , B              '\
LINE (353, 407)-(533, 477), , B              ' |
LINE (387, 407)-(387, 477)                   '  > Afr
LINE (389, 407)-(389, 477)                   ' |
LINE (390, 408)-(532, 476), digit_back, BF   '/
DRAW "c1 b m639,479 p1,15"
IF Screen_mode = 12 THEN COLOR 11
LOCATE 18, 3:  PRINT "Crossings/10 seconds"
LOCATE 18, 26: PRINT "Oxygen Percentage"
LOCATE 18, 54: PRINT "Lambda"
LOCATE 26, 25: PRINT "Maximum:";
LOCATE 27, 25: PRINT "Average:";
LOCATE 28, 25: PRINT "Minimum:";
LOCATE 29, 25: PRINT "   Time:";
LOCATE 28, 46: PRINT "AFR";
IF Screen_mode = 12 THEN COLOR 15
LOCATE 18, 68: PRINT " "; EE$; " "
LOCATE 19, 68: PRINT "  "; AA$; "  "
LOCATE 20, 68: PRINT " ------------"
LOCATE 21, 68: PRINT "             "
IF Auto_save = 1 THEN
   LOCATE 22, 68: PRINT " Autosave ON "
   LOCATE 23, 68: PRINT "             "
   LOCATE 24, 68: PRINT "             "
   LOCATE 25, 68: PRINT "             "
   LOCATE 26, 68: PRINT "             "
   LOCATE 27, 68: PRINT "             "
ELSE
   LOCATE 22, 68: PRINT "             "
   LOCATE 23, 68: PRINT "             "
   LOCATE 24, 68: PRINT "             "
   LOCATE 25, 68: PRINT "             "
   LOCATE 26, 68: PRINT "             "
   LOCATE 27, 68: PRINT "             "
END IF

LOCATE 28, 68: PRINT " Press <ESC> "
LOCATE 29, 68: PRINT "for main menu";
LOCATE 30, 68: PRINT "             ";

'_________________________________________________________________________
'|                                                                        |
'|        Clear trace window, draw grid and legend                        |
'|________________________________________________________________________|

DO

LINE (x_min, y_min)-(x_max, y_max), trace_background, BF           'Clear trace
LINE (x_min, y_max - stoich_y)-(x_max, y_max - stoich_y), 3, , 255 'stoichmetric point
LOCATE 16, 68: PRINT "stochiometry"
LINE (x_max - 110, y_max - 28)-(x_max - 10, y_max - 28), 3, , 255  'stoichmetric point
LOCATE 14, 70: PRINT "average"
LINE (x_max - 110, y_max - 56)-(x_max - 10, y_max - 56), 12, , 21845

FOR grid_y = y_max TO y_min STEP 0 - (pix_per_volt * volt_per_div)
   LINE (x_min, grid_y)-(x_max, grid_y), grid_colour
NEXT

'_________________________________________________________________________
'|                                                                        |
'|                            Draw trace                                  |
'|________________________________________________________________________|

IF Saved_trace = 0 THEN
  DEF SEG = VARSEG(prog(1))
  CALL absolute(y(x_min), p)
  PSET (x_min, y_max - y(x_min)), trace
  time = TIMER
  FOR x = x_min TO x_max
    CALL absolute(y(x), p)
    LINE -(x, y_max - y(x)), trace
  NEXT
  time = TIMER - time
  Sample_time = (time) / number_samples
ELSE
   IF LEN(freql.Dirlabel.caption) < 3 THEN
      OPEN freql.FileLabel.caption FOR INPUT AS #2
   ELSE
      OPEN freql.Dirlabel.caption + "\" + freql.FileLabel.caption FOR INPUT AS #2
   END IF
   INPUT #2, Sample_time
   INPUT #2, y(0)
   PSET (x_min, y_max - y(0))
   FOR x = x_min TO x_max
      INPUT #2, y(x)
      LINE -(x + x_min, y_max - y(x)), trace
   NEXT
CLOSE 2
END IF
LOCATE 21, 68: PRINT "             "
LOCATE 22, 68: PRINT "             "
LOCATE 23, 68: PRINT "             "
LOCATE 24, 68: PRINT " Thinking... "
LOCATE 25, 68: PRINT "             "
LOCATE 26, 68: PRINT "             "
LOCATE 27, 68: PRINT "             "
LOCATE 28, 68: PRINT "             "
LOCATE 29, 68: PRINT "             ";
LOCATE 30, 68: PRINT "             ";
'_________________________________________________________________________
'|                                                                        |
'|                           Count crossings                              |
'|________________________________________________________________________|

  maximum_y = y_min
  minimum_y = y_max
  crossings = 0
  y_total = 0

  FOR x = x_min TO x_max
  y_total = y_total + y(x)
  NEXT

  average_y = y_total / number_samples
  LINE (x_min, y_max - average_y)-(x_max, y_max - average_y), 12, , 21845

  FOR x = x_min TO x_max
     a = ((y(x) >= average_y) AND (y(x + 1) < average_y))
     B = ((y(x) <= average_y) AND (y(x + 1) > average_y))
     IF a OR B THEN
        crossings = crossings + 1: last_cross = x
        IF crossings = 1 THEN first_cross = x
     END IF
     IF y(x) < minimum_y THEN minimum_y = y(x)
     IF y(x) > maximum_y THEN maximum_y = y(x)
  NEXT
'_________________________________________________________________________
'|                                                                        |
'|                Calculate lambda, AFR and oxygen percentage             |
'|________________________________________________________________________|

  IF crossings > 4 THEN
     lambda = INT((((0 - average_y / pix_per_volt) + 27.45) / 27) * 100) / 100
     afr = INT((ideal_afr * lambda) * 10) / 10
     oxygen = INT(((lambda - .93) / .0803) * 10) / 10
  END IF

'_________________________________________________________________________
'|                                                                        |
'|                            More screen stuff                           |
'|________________________________________________________________________|

IF Auto_save = 1 THEN
   LOCATE 22, 68: PRINT " Autosave ON "
   LOCATE 23, 68: PRINT "             "
   LOCATE 24, 68: PRINT " Saved trace "
   LOCATE 25, 68: PRINT "      as     "
   LOCATE 26, 68: PRINT " "; File_Name$
   LOCATE 27, 68: PRINT "             "
ELSE
  IF Saved_trace = 1 THEN
     LOCATE 22, 68: PRINT "             "
     LOCATE 23, 68: PRINT "  Currently  "
     LOCATE 24, 68: PRINT "  displaying "
     LOCATE 25, 68: PRINT "             "
     LOCATE 26, 68: PRINT " "; File_Name$
     LOCATE 27, 68: PRINT "             "
  
     ELSE
       IF cont = 0 THEN
          LOCATE 22, 68: PRINT "             "
          LOCATE 23, 68: PRINT "    Press    "
          LOCATE 24, 68: PRINT "   <SPACE>   "
          LOCATE 25, 68: PRINT "   to save   "
          LOCATE 26, 68: PRINT "             "
          LOCATE 27, 68: PRINT "             "

      ELSE
          LOCATE 22, 68: PRINT "             "
          LOCATE 23, 68: PRINT "             "
          LOCATE 24, 68: PRINT "             "
          LOCATE 25, 68: PRINT "             "
          LOCATE 26, 68: PRINT "             "
          LOCATE 27, 68: PRINT "             "
         
      END IF
  END IF
END IF
LOCATE 28, 68: PRINT " <ESC> to get"
LOCATE 29, 68: PRINT " back to main";
LOCATE 30, 68: PRINT " menu        ";
'_________________________________________________________________________
'|                                                                        |
'|                           Go and draw big numbers                      |
'|________________________________________________________________________|

cross_xpos = 95 - (LEN(STR$(crossings)) - 1) * 25
LINE (13, 291)-(176, 397), digit_back, BF
CALL BIGNUM(crossings, 8, cross_xpos, 310)

IF oxygen < 0 OR oxygen > 9.9 THEN oxygen = overflow
LINE (188, 291)-(342, 376), digit_back, BF
CALL BIGNUM(oxygen, 6, 210, 310)

LINE (13, 408)-(176, 476), digit_back, BF
PRESET (30, 460)
IF average_y < stoich_y THEN DRAW Lean$ ELSE DRAW Rich$

IF lambda < 0 OR lambda > 9.9 THEN lambda = overflow
LINE (354, 291)-(532, 397), digit_back, BF
CALL BIGNUM(lambda, 8, 361, 310)

LINE (390, 408)-(532, 476), digit_back, BF
CALL BIGNUM(afr, 6, 394, 416)
IF Screen_mode = 12 THEN COLOR 15

LOCATE 26, 33: PRINT "          "
LOCATE 26, 33: PRINT INT(maximum_y / pix_per_volt * 1000); "mV"
LOCATE 27, 33: PRINT "          "
LOCATE 27, 33: PRINT INT(average_y / pix_per_volt * 1000); "mV"
LOCATE 28, 33: PRINT "          ";
LOCATE 28, 33: PRINT INT(minimum_y / pix_per_volt * 1000); "mV";
LOCATE 29, 33: PRINT "          ";
LOCATE 29, 33: PRINT INT(time * 100) / 100; "sec";
a$ = INKEY$: IF a$ = CHR$(27) THEN GOTO theend

'_________________________________________________________________________
'|                                                                        |
'|                         Reset variables                                |
'|________________________________________________________________________|

crossings = overflow
average_y = maximum_y - minimum_y / 2
lambda = overflow
afr = overflow
oxygen = overflow

'_________________________________________________________________________
'|                                                                        |
'|                      Save trace if needed                              |
'|________________________________________________________________________|

FOR Empty_Keyboard_buffer = 1 TO 100: a$ = INKEY$: NEXT
a$ = INKEY$

IF Sample_and_hold = 1 OR Saved_trace = 1 THEN
   DO
     a$ = INKEY$
   LOOP UNTIL a$ <> "" OR cont = 1
END IF
'IF cont = 1 THEN
 '  if a$
 '  FOR i = 0 TO 640: z(i) = y(i): NEXT
 '  BEEP: BEEP
  ' save = 1: GOTO theend
'END IF

IF Sample_and_hold = 1 AND a$ = " " THEN
   FOR i = 0 TO 640: z(i) = y(i): NEXT
   FOR Empty_Keyboard_buffer = 1 TO 100: a$ = INKEY$: NEXT
   save = 1: GOTO theend
END IF

IF Auto_save = 1 AND Saved_trace = 0 THEN
   n = VAL(RIGHT$(File_Name$, 2)) + 1
   IF n > 99 THEN n = 1
   n$ = RIGHT$("00" + MID$(STR$(n), 2), 2)
   File_Name$ = LEFT$(File_Name$, LEN(File_Name$) - 4) + ".#" + n$
   OPEN File_Name$ FOR OUTPUT AS #2
   PRINT #2, Sample_time
   FOR i = x_min TO 640
     PRINT #2, MID$(STR$(y(i)), 2) + CHR$(13);
   NEXT
   CLOSE #2
   BEEP
END IF

LOOP UNTIL a$ = CHR$(27)
'_________________________________________________________________________
'|                                                                        |
'|                           Clean up and exit                            |
'|________________________________________________________________________|

theend:
FOR Empty_Keyboard_buffer = 1 TO 100: a$ = INKEY$: NEXT

SCREEN 0
screen.SHOW
outofhere:
EXIT SUB

ErrorHandler:
SCREEN 0
screen.SHOW

MSGBOX "** Error **"
RESUME outofhere
END SUB

DEFINT P
SUB setupvars ()
ON LOCAL ERROR GOTO ErrHandler

SHARED prog()  AS INTEGER
SHARED p
SHARED EE$, AA$, a$, B$, c$, d$, E$, f$, G$, dp$, Digit() AS STRING
SHARED Rich$, Lean$
SHARED boot_dir AS STRING
SHARED Screen_mode, Delay_Value, port$, File_Name$, Saved_trace
SHARED cont, Sample_and_hold, Auto_save, save, z(), Sample_time
SHARED cal()
q$ = "Fmfduspojdt"
FOR i = 1 TO 11
EE$ = EE$ + CHR$(ASC(MID$(q$, i, 1)) - 1)
NEXT

q$ = "Bvtusbmjb"
FOR i = 1 TO 11
AA$ = AA$ + CHR$(ASC(MID$(q$, i, 1)) - 1)
NEXT

boot_dir$ = CURDIR$
Screen_mode = 12
Delay_Value = 10
port$ = "0378"
Auto_save = 0
save = 0
File_Name$ = "EGO-save.#00"

ego.maintitle.caption = "Loading Configuration file"

ErrorFlag = 0
OPEN "ego.cfg" FOR INPUT AS #2
 IF ErrorFlag = 0 THEN
   INPUT #2, a$: Screen_mode = VAL(MID$(a$, 16))
   INPUT #2, a$: Delay_Value = VAL(MID$(a$, 16))
   INPUT #2, a$: port$ = MID$(a$, 16)
CLOSE #2
 END IF

cfg.porttxt.text = port$
cfg.delaytxt.text = STR$(Delay_Value / 10)
IF Screen_mode = 11 THEN
   cfg.monomode.value = -1
  ELSE
      cfg.colmode.value = -1
END IF

ErrorFlag = 0
OPEN "EGO.CAL" FOR INPUT AS #2
IF ErrorFlag = 0 THEN
    FOR i = 0 TO 25
      INPUT #2, cal(i * 10)
   NEXT
   CLOSE #2
   cal(260) = 0
END IF

FOR i = 0 TO 260 STEP 10
   a = cal(i): B = cal(i + 10)
   c = (B - a) / 10
   FOR x = 1 TO 9
      cal(i + x) = cal(i + x - 1) + c
   NEXT
NEXT

cfg.portadd.ADDITEM "0378"
cfg.portadd.ADDITEM "0278"
cfg.portadd.ADDITEM "01BC"
cfg.portadd.ADDITEM "02BC"

FOR i = 1 TO 100
   cfg.delayvalue.ADDITEM STR$(i)
NEXT

FOR i = 0 TO 128 STEP 5
   v$ = STR$(i / 100)
   q$ = SPACE$(6 - LEN(v$)) + "volts"
   v$ = v$ + q$
   IF i = 45 THEN v$ = v$ + " (stoichiometry)"
   gen.voltlist.ADDITEM v$
NEXT


cr$ = CHR$(13) + CHR$(10)
q$ = "QD.Esjwfo!FHP!bobmztfs"
FOR i = 1 TO 22
PC$ = PC$ + CHR$(ASC(MID$(q$, i, 1)) - 1)
NEXT
q$ = "Wfstjpo!2/2"
FOR i = 1 TO 11
vv$ = vv$ + CHR$(ASC(MID$(q$, i, 1)) - 1)
NEXT
q$ = ")Kbovbsz!2::7*"
FOR i = 1 TO 14
nn$ = nn$ + CHR$(ASC(MID$(q$, i, 1)) - 1)
NEXT

intro$ = PC$
intro$ = intro$ + cr$ + vv$ + cr$ + cr$
intro$ = intro$ + EE$ + " " + AA$
intro$ = intro$ + cr$
intro$ = intro$ + nn$

ego.maintitle.caption = intro$
cfg.syscfgtitle.caption = intro$
gen.gentitle.caption = intro$

a$ = "c12 f3 r12 e3 h1 l16 g1 b r1 p12,12 l1"
B$ = "c12 g3 d12 f3 e1 u16 h1 b d1 p12,12 u1"
c$ = B$
d$ = "c12 f1 r16 e1 h3 l12 g3 b r1 p12,12 l1"
E$ = "c12 g1 d16 f1 e3 u12 h3 b d1 p12,12 u1"
f$ = E$
G$ = "c12 f2 r14 e2 h2 l14 g2 b r1 p12,12 l1"
Digit$(1) = "B r18" + B$ + "d18" + c$
Digit$(2) = a$ + "r18" + B$ + "d18 b l18" + G$ + f$ + "d18" + d$
Digit$(3) = a$ + "r18" + B$ + "d18 b l18" + G$ + "r18" + c$ + "d18 b l18" + d$
Digit$(4) = f$ + "b r18" + B$ + "d18 b l18" + G$ + "r18" + c$
Digit$(5) = a$ + f$ + "d18" + G$ + " r18" + c$ + "d18 b l18" + d$
Digit$(6) = Digit$(5) + "b u18" + E$
Digit$(7) = a$ + Digit$(1)
Digit$(0) = f$ + Digit$(7) + "d18 b l18" + d$ + "b u18" + E$
Digit$(8) = Digit$(0) + G$
Digit$(9) = f$ + "d18" + G$ + "u18" + Digit$(7) + "d18 b l18" + d$
dp$ = "c12 b d37 b l7 u5 r5 d5 l5 b e1 p12,12"
Rich$ = "c14 S8 b r5 U18 R9 F3 D4 G3 b L5 D8 L4 b u8 b r4 m+4,8 r4 m-4,-8 "
Rich$ = Rich$ + "b u3 b l4 u4 r4 f1 d2 g1 l4 b d1 p14,14 "
Rich$ = Rich$ + "b d10 b r12 u18 r4 d18 l4 b e1 p14,14"
Rich$ = Rich$ + "b r10 b d1 h3 u12 e3 r7 f3 d2 l3 u1 l5 g1 d8 f1 r5 u1 r3 d2 g3 l7 b u1 p14,14"
Rich$ = Rich$ + "b r13 b d1 u18 r4 d7 r5 u7 r4 d18 l4 u7 l5 d7 l4 b e1 p14,14"
Lean$ = "c14 S8 u18 r4 d14 r8 d4 l12 b e1 p14,14"
Lean$ = Lean$ + "d1 b r14 u18 r12 d4 l8 d3 r8 d4 l8 d3 r8 d4 l12 b e1 p14,14"
Lean$ = Lean$ + "d1 b r12 m+7,-18 r4 m+7,18 l5 m-2,-5 l4 m-2,5 l5 b u8 b r7 m+2,-4 m+2,+4 l3 b l2 p14,14"
Lean$ = Lean$ + "b d8 b r13 u18 r6 m+7,13 u13 r4 d18 l6 m-7,-13 d13 l4 b e1 p14,14"
OUT (VAL("&H" + port$)), &HC7


ErrHandler:

ErrorFlag = ERR
RESUME NEXT

END SUB

DEFSNG P
SUB zzzt (volts)


SHARED cal(), port$
OUT (VAL("&H" + port$)), &HC7
v = volts / (1.28 / 255)
k = INT(v + cal(v))
FOR j = 0 TO k
   OUT (VAL("&H" + port$)), &HFF
   OUT (VAL("&H" + port$)), &HF8
NEXT
MSGBOX "Generating" + STR$(volts) + " volts."
OUT (VAL("&H" + port$)), &HC7

END SUB

